/* XmGoBang: (c) 1995-2008 by Andreas S. Krebs */

#include "xmgobang.h"

#include "pixmaps/stonecursor.xbm"
#include "pixmaps/stonecursor_mask.xbm"

#include "pixmaps/waitcursor.xbm"
#include "pixmaps/waitcursor_mask.xbm"

#define cursor_hot_x	7
#define cursor_hot_y	8

/* some local variables */

static Widget gfxWidget;
static Pixmap stonePixmap, stone_maskPixmap;
static Pixmap waitPixmap, wait_maskPixmap;
static Cursor playerCursor[2], waitCursor;


/************************************************************************
 *									*
 * change the cursor for the drawing area			 	*
 *  									*
 ************************************************************************/

void setCursor(short nr)
{    
  if(nr==GAME_FINISHED)
    XDefineCursor(display,XtWindow(gfxWidget), waitCursor);    
  else if(XGoGame.Player[nr].Type==PLAYER_HUMAN)
    XDefineCursor(display,XtWindow(gfxWidget),playerCursor[nr]);      
  else
    XDefineCursor(display,XtWindow(gfxWidget),waitCursor);
}


/************************************************************************
 *									*
 * create the cursors for the drawing area			 	*
 *  									*
 ************************************************************************/

void createCursors(Widget widget)
{
  XColor	fgCol, bgCol;
  Window	root;
  Screen	*screen;

  gfxWidget=widget;
  screen=XtScreen(widget);
  root=RootWindowOfScreen(screen);
  
  stonePixmap=XCreatePixmapFromBitmapData
    (display, root, stonecursor_bits, stonecursor_width, stonecursor_height, 
     1, 0, 1);
  
  stone_maskPixmap=XCreatePixmapFromBitmapData
    (display, root, stonecursor_mask_bits, stonecursor_mask_width, stonecursor_mask_height, 
     1, 0, 1);

  fgCol.pixel=XGoGame.Player[0].Color;
  XQueryColor(display, DefaultColormapOfScreen(screen), &fgCol);

  bgCol.pixel=XGoGame.Player[0].TopColor;
  XQueryColor(display, DefaultColormapOfScreen(screen), &bgCol);

  playerCursor[0]=XCreatePixmapCursor(display, stonePixmap, stone_maskPixmap,
				      &fgCol, &bgCol, cursor_hot_x, cursor_hot_y);

  fgCol.pixel=XGoGame.Player[1].Color;
  XQueryColor(display, DefaultColormapOfScreen(screen), &fgCol);

  bgCol.pixel=XGoGame.Player[1].TopColor;
  XQueryColor(display, DefaultColormapOfScreen(screen), &bgCol);
  
  playerCursor[1]=XCreatePixmapCursor(display, stonePixmap, stone_maskPixmap,
				      &fgCol, &bgCol, cursor_hot_x, cursor_hot_y);  

  
  waitPixmap=XCreatePixmapFromBitmapData
    (display, root, waitcursor_bits, waitcursor_width, waitcursor_height, 
     1, 0, 1);
  
  wait_maskPixmap=XCreatePixmapFromBitmapData
    (display, root, waitcursor_mask_bits, waitcursor_mask_width, waitcursor_mask_height, 
     1, 0, 1);

  fgCol.pixel=BlackPixelOfScreen(screen);;
  XQueryColor(display, DefaultColormapOfScreen(screen), &fgCol);

  bgCol.pixel=WhitePixelOfScreen(screen);
  XQueryColor(display, DefaultColormapOfScreen(screen), &bgCol);

  waitCursor=XCreatePixmapCursor(display, waitPixmap, wait_maskPixmap,
				 &fgCol, &bgCol, cursor_hot_x, cursor_hot_y);
}


/************************************************************************
 *									*
 * free all cursors 						 	*
 *  									*
 ************************************************************************/

void destroyCursors()
{
  XFreeCursor(display, playerCursor[0]);
  XFreeCursor(display, playerCursor[1]);
  XFreeCursor(display, waitCursor);  
  
  XFreePixmap(display, stone_maskPixmap);
  XFreePixmap(display, stonePixmap);
  XFreePixmap(display, wait_maskPixmap);
  XFreePixmap(display, waitPixmap);
}
