/* XmGoBang: (c) 1995-2008 by Andreas S. Krebs */

#include "xmgobang.h"

/* local prototypes */

static void insertTextfile(Widget, String);
    

/************************************************************************
 *									*
 * Callback procedure for the `help` on GoBang menu item	 	*
 *  									*
 ************************************************************************/

void helpCB(Widget widget , XtPointer client_data, XtPointer call_data)
{
  static Widget helpShell=NULL;

  if(helpShell==NULL)
  {
    Widget	bullW, formW, textW, sepW, buttonW;
    Arg		args[20];
    Cardinal	n;

    n=0;
    XtSetArg(args[n], XmNtitle, "Help on XmGoBang:");	n++; 
    bullW=XmCreateBulletinBoardDialog(applShell,"onXmGoBang", args, n);
        
    helpShell=XtParent(bullW);
    
    n=0;
    XtSetArg(args[n], XmNhorizontalSpacing, 6);		n++;
    XtSetArg(args[n], XmNverticalSpacing, 6);		n++;
    formW=XtCreateManagedWidget("helpForm",xmFormWidgetClass, bullW, args, n);
    
    n=0;       
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);	n++;
    XtSetArg(args[n], XmNalignment, XmALIGNMENT_CENTER);	n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_POSITION);	n++;
    XtSetArg(args[n], XmNleftPosition, 25);			n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_POSITION);	n++;
    XtSetArg(args[n], XmNrightPosition, 75);			n++;
    buttonW=XtCreateManagedWidget("helpOk", xmPushButtonWidgetClass, formW,
				  args, n);
    XtAddCallback(buttonW, XmNactivateCallback, (XtCallbackProc)popdownCB, 
		  (XtPointer)helpShell);
    
    
    n=0;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET);	n++;
    XtSetArg(args[n], XmNbottomWidget, buttonW);		n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);	n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);	n++;
    sepW=XtCreateManagedWidget("helpSep", xmSeparatorWidgetClass, formW,
			       args, n);
    
    n=0;
    XtSetArg(args[n], XmNeditable, False);			n++;
    XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT);		n++;
    XtSetArg(args[n], XmNcursorPositionVisible, False);		n++;
    XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);	n++;
    XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);		n++;
    XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);	n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET);	n++;
    XtSetArg(args[n], XmNbottomWidget, sepW);			n++;
    textW=XmCreateScrolledText(formW, "helpText", args, n);    

    insertTextfile(textW, HELP_FILE);
    
    XtManageChild(textW);

    setCloseCallback(helpShell, (XtCallbackProc)popdownCB, (XtPointer)helpShell);
    
    XtManageChild(bullW);
  }
  else
    XtPopup(helpShell, XtGrabExclusive);
}


/************************************************************************
 *									*
 * insert text from file into XmText widget			 	*
 *  									*
 ************************************************************************/

static void insertTextfile(Widget textW, String filename)
{
  FILE	*f_in;
  char	buf[1024];
  long	len, pos=0;
  
  if(f_in=fopen(filename, "r"))
  {
    XmTextSetString(textW, "");
    
    do
    {
      len=fread(buf, 1, 1000, f_in);
      buf[len]=0;			/* make it a correct string */
      XmTextInsert(textW, pos, buf);
      
      pos+=1000;
    }while(len>=1000);
    
    fclose(f_in);
  }
  else
  {
    strcpy(buf,"unable to load help file: ");
    strcat(buf, filename);

    XmTextSetString(textW, buf);
  }
}


/************************************************************************
 *									*
 * display Info about author					 	*
 *  									*
 ************************************************************************/

static String about_txt="XmGoBang v0.52\n\n(c) 1995-2008 by Andreas S. Krebs\n\nhttp://www.sberk.net/xmgobang\nxmgobang@sberk.net";
static String version_txt="XmGoBang v0.52";

void aboutCB(Widget widget , XtPointer client_data, XtPointer call_data)
{
  static Widget aboutW=NULL;
  static Widget dialogShell=NULL;

  if(aboutW==NULL)
  {
    Arg			args[10];
    Cardinal		n;
    Widget		childW;
    XmString		cstring1, cstring2;
    
    cstring1=XmStringCreateSimple(version_txt);
    cstring2=XmStringCreateLtoR(about_txt, XmSTRING_DEFAULT_CHARSET);
    
    n=0;
    XtSetArg(args[n], XmNautoUnmanage, False); 				n++;
    XtSetArg(args[n], XmNdialogStyle, XmDIALOG_APPLICATION_MODAL); 	n++;
    XtSetArg(args[n], XmNdialogTitle, cstring1);			n++;
    XtSetArg(args[n], XmNmessageString, cstring2);			n++;
    aboutW=XmCreateMessageDialog(applShell, "aboutXmGoBang", args, n);
    XmStringFree(cstring1);
    XmStringFree(cstring2);
    
    dialogShell=XtParent(aboutW);

    n=0;
    XtSetArg(args[n], XmNdeleteResponse, XmDO_NOTHING);	n++;
    XtSetValues(dialogShell, args, n);
    
    XtAddCallback(aboutW, XmNokCallback, popdownCB, (XtPointer)dialogShell);

    XtUnmanageChild(XmMessageBoxGetChild(aboutW,XmDIALOG_CANCEL_BUTTON));    
    XtUnmanageChild(XmMessageBoxGetChild(aboutW,XmDIALOG_HELP_BUTTON));
    
    childW=XmMessageBoxGetChild(aboutW, XmDIALOG_MESSAGE_LABEL);
    
    setCloseCallback(dialogShell, (XtCallbackProc)popdownCB, (XtPointer)dialogShell);
    
    XtManageChild(aboutW);
  }
  else
    XtPopup(dialogShell, XtGrabExclusive);
}


